import * as server from '@minecraft/server'
import * as ui from '@minecraft/server-ui'
const world = server.world

world.beforeEvents.chatSend.subscribe((ev) => {
    const player = ev.sender
    const msg = ev.message

    if (msg == "-mode") {
        ev.cancel = true
        if (player.hasTag("admin")) {
            player.runCommandAsync('tellraw @s {"rawtext":[{"text":"you have 0.5 seconds to close chat"}]}')
            server.system.runTimeout(() => {
                actionform.show(player).then((response) => {
                    if (response.selection === 0) {
                        player.runCommandAsync("gamemode 1")
                        return -1;
                    }
                    if (response.selection === 1) {
                        player.runCommandAsync("gamemode 0")
                        return -1;
                    }
                    if (response.selection === 2) {
                        player.runCommandAsync("gamemode 2")
                        return -1;
                    } if (response.selection === 3) {
                        player.runCommandAsync("gamemode spectator")
                        return -1;
                    }
                });
            }, 10)
        }
    }
})
function detect(player) {
    if (player.hasTag("mode")) {
        player.removeTag("mode")
        actionform.show(player).then((response) => {
            if (response.selection === 0) {
                player.runCommandAsync("gamemode 1")
                return -1;
            }
            if (response.selection === 1) {
                player.runCommandAsync("gamemode 0")
                return -1;
            }
            if (response.selection === 2) {
                player.runCommandAsync("gamemode 2")
                return -1;
            } if (response.selection === 3) {
                player.runCommandAsync("gamemode spectator")
                return -1;
            }
        })
    }
}

const actionform = new ui.ActionFormData()
    .title("Change Gamemode")
    .button("Creative")
    .button("Survival")
    .button("Adventure")
    .button("Spectator");

import { world, system } from '@minecraft/server';

system.runInterval(() => {
    let players = world.getAllPlayers()
    players.forEach(detect)
})